Description

"linuxefi"and "initrdefi" are not avaliable in RHEL8, Once foreman-installer copies grubx64.efi from the foreman host (supposedly

RHEL8 on current foreman) to /var/lib/tftpboot/grub2 provisioning and discovery PXE GRUB2 boot fails. Since foreman in RHEL7 is

deprecated the references to "linuxefi"and "initrdefi" should be removed from the templates.

Example patch attached.

History

#1 - 01/10/2023 07:24 PM - Zailo Leite

- Description updated

#2 - 01/10/2023 07:27 PM - Zailo Leite

- File Kickstart_default_PXEGrub2.patch added

- Description updated

#3 - 01/10/2023 07:29 PM - Zailo Leite

- Description updated

#4 - 01/10/2023 07:29 PM - Zailo Leite

- Description updated

#5 - 01/10/2023 10:39 PM - Ewoud Kohl van Wijngaarden

Reading the source, this should automatically happen already if the OS has a proper major version set. Your patch should have no effect on EL7+.

Can you share what the OS major is set to for you?

#6 - 01/10/2023 11:02 PM - Zailo Leite

The foreman host is 8.7

I'm not sure if I follow. The default template creates an output like:

=====

if [ ${grub_platform}  "pc" ]; then

menuentry 'Foreman Discovery Image' --id discovery {

linux boot/fdi-image/vmlinuz0 ${common}

initrd boot/fdi-image/initrd0.img

}

else

menuentry 'Foreman Discovery Image EFI' --id discovery {

linuxefi boot/fdi-image/vmlinuz0 ${common}

initrdefi boot/fdi-image/initrd0.img

}

fi

===
This will fail with with grubx64.efi from grub2-efi-x64-2.02-142 .

#7 - 01/10/2023 11:04 PM - Zailo Leite

Typical error is:

error: …/…/grub-core/script/lexer.c:352:syntax error.

error: …/…/grub-core/script/lexer.c:352:Incorrect command.

#8 - 01/10/2023 11:40 PM - Ewoud Kohl van Wijngaarden

I was asking about the Operating System as you have configured it in the application itself. Every host in Foreman is assigned an Operating System

and that has a major version.

However, now that I reread it I wonder if the code is correct.

Either way, submitting it as a pull request on GitHub allows for proper discussion. Patches in Redmine typically get lost.

#9 - 01/11/2023 03:17 AM - Zailo Leite

Created https://github.com/theforeman/foreman/pull/9580

Files

Kickstart_default_PXEGrub2.patch 2.16 KB 01/10/2023 Zailo Leite
